import { SnowflakeJSPrimitive } from '../snowflake-core';
import "reflect-metadata";
export declare type Constructor<T> = new (...args: any[]) => T;
export declare type SnowflakeObject<T = any> = {
    [P in keyof T]: SnowflakeJSPrimitive;
};
export interface TableDefinition {
    name: string;
    columnNames: Array<string>;
    propertyToColumnMappings: {
        [key: string]: string;
    };
}
export declare const Mapper: {
    getSchema<T>(ctr: Constructor<T>): TableDefinition;
    fromRow<T_1>(ctr: Constructor<T_1>, row: Record<string, any>): T_1;
    toRow<T_2>(ctr: Constructor<T_2>, object: SnowflakeObject<T_2>): SnowflakeObject;
};
