import { SnowflakeObject } from './mapping/mapper';
import { SnowflakeJSPrimitive } from './snowflake-core';
import './promise-extensions';
import './stream-extensions';
export declare type Operator = "<" | "<=" | "==" | ">=" | ">";
export declare type Comparison<T extends SnowflakeJSPrimitive> = {
    operand: T;
    operator: Operator;
};
export declare type Query<T> = {
    [P in keyof T]: Comparison<SnowflakeObject<T>[P]> | SnowflakeJSPrimitive;
};
