import { TableDefinition, SnowflakeObject } from './mapping/mapper';
import { SnowflakeJSPrimitive, SqlCommand } from 'snowflake-core';
import { Query } from './queries';
export declare class SqlGenerator {
    private static isOperand;
    static generateWhereClause<T>(query: Query<T>, mappings: Record<string, string>): SqlCommand;
    static generateSelect<T = any>(table: TableDefinition, query?: Query<T>): {
        sqlText: string;
        binds: (string | number | boolean | Date | SnowflakeJSPrimitive[] | undefined)[] | undefined;
    };
    static generateBatchInsert(tableName: string, rows: Array<SnowflakeObject>): SqlCommand;
}
